#include <iostream>
#include <vector>

class Book {
public:
    Book() : title {""}, price {0}
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
    Book(std::string title, int price)
        : title {title}, price {price}
    {
    }

    Book(std::string title)
        : title {title}, price {0}
    {
    }

    Book(int price)
        : title {""}, price {price}
    {
    }
    ~Book()
    {
         std::cout << __PRETTY_FUNCTION__ << '\n';
    }

    void PrintBook() const
    {
        std::cout << title << ' ' << price << '\n';
    }
private:
    std::string title;
    int price;
};

int main()
{
    std::vector<Book*> books =
                 {
                     new Book(), new Book("Ion", 20),
                     new Book("Rascoala"), new Book(30)
                 };

    for (int i = 0; i < books.size(); ++i)
        books[i]->PrintBook();
    std::cout << '\n';

    for (std::vector<Book*>::iterator it = books.begin();
         it != books.end(); ++it )
            (*it)->PrintBook();
    std::cout << '\n';

    for (auto it = books.begin();
         it != books.end(); ++it )
            (*it)->PrintBook();
    std::cout << '\n';

    for (auto pBook : books)
            pBook->PrintBook();
    std::cout << '\n';

    for (auto& pBook : books)
            delete pBook;
}
